#include <stdio.h>

int main (void)
{
  int p = 7;       // geheimer Schlüssel
  int q = 11;      // geheimer Schlüssel
  int d = 1;       // geheimer Schlüssel
  int e = 13;      // öffentlicher Schlüssel
  while ((e * d) % ((p - 1) * (q - 1)) != 1)
    d++;
  int N = p * q;   // öffentlicher Schlüssel
  int m = 12;      // Nachricht
  int c = 1;       // verschlüsselte Nachricht ("Chiffrat")
  // c = m hoch e modulo N
  for (int i = 0; i < e; i++)   // O(n) mit n = e, z.B. e = 2 hoch 2048
    c = (c * m) % N;            // O(2^n) mit n = Anzahl der Bits in e --> langsam
  printf ("Verschlüsselte Nachricht: c = %d\n", c);
  m = 1;
  // m = c hoch d modulo N
  for (int i = 0; i < d; i++)
    m = (m * c) % N;
  printf ("Entschlüsselte Nachricht: m = %d\n", m);
  return 0;
}
