#include <stdio.h>

int binexp (int b, int e, int N)
{
  if (e == 4)
    {
      b *= b;
      b *= b;
      return b;
    }
  else if (e == 5)
    {
      int orig_b = b;
      b *= b;
      b *= b;
      b *= orig_b;
      return b;
    }
  else if (e == 13)
    {
      int orig_b = b;
      b *= b;
      b *= b;
      int b_4 = b;
      b *= b;
      b *= orig_b * b_4;
      return b;
    }
  else
    {
      int result = 0;
      for (int i = 0; i < e; i++)   // geschummelt
        result *= b;
      return result;
    }
}

int main (void)
{
  int p = 7;       // geheimer Schlüssel
  int q = 11;      // geheimer Schlüssel
  int d = 1;       // geheimer Schlüssel
  int e = 13;      // öffentlicher Schlüssel
  while ((e * d) % ((p - 1) * (q - 1)) != 1)
    d++;
  int N = p * q;   // öffentlicher Schlüssel
  int m = 12;      // Nachricht
  int c = 1;       // verschlüsselte Nachricht ("Chiffrat")
  // c = m hoch e modulo N
  c = binexp (m, e, N);
  printf ("Verschlüsselte Nachricht: c = %d\n", c);
  // m = c hoch d modulo N
  m = binexp (c, d, N);
  printf ("Entschlüsselte Nachricht: m = %d\n", m);
  return 0;
}
